/*
 * COMP 15 Sample solution for typing practice problem 
 */
import java.io.*;
public class Main
{
	public static void main(String[] args)
	{
		System.out.println("Welcome to typing practice.");
		practice();
		System.out.println("Practice is finished.");
		getInput("Press Return to exit.");
	}
	
	
    // accept input text until all characters seen.
	private static void practice()
	{
		Seen seenSoFar = new Seen();
		
		boolean done = false;
		while (!done)
		{
			// show characters remaining
			seenSoFar.printUnseen();
			
			// get a line of text
			String s = getInput("Type some text:  ");
			String t = s.toLowerCase();
			
			// update each lower case character in input as seen
			for (int i = 0; i < t.length(); i++)
			{
				seenSoFar.update(t.charAt(i));
			}
			
			// are we done now?
			done = seenSoFar.allSeen();
		}
	}
	
	
    /*
	 * getInput:  print string prompt and return text entered as 
	 *       a string.
     * returns empty string if an error occurs
	 */
    private static BufferedReader bufStdInput;  // access to keyboard input stream
	private static String getInput(String prompt)
	{		
		// initialize input stream on initial use
		if (bufStdInput == null)
		{
			bufStdInput = new BufferedReader(new InputStreamReader(System.in));
		}
		
		// prompt for input
		System.out.print(prompt);
		System.out.flush();
		
		// read input line
		while (true){
			try {
				return bufStdInput.readLine();
			}
			catch (IOException e) {
				return "";
			}	
		}
	}
}
